#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,_TMP_ADD10_OUT)
  __DECLARE_VAR(BOOL,_TMP_EQ13_OUT)
  __DECLARE_VAR(UINT,_TMP_SEL15_OUT)
  __DECLARE_VAR(BOOL,_TMP_AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM INOUTCHK
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(BOOL,IN0)
  __DECLARE_EXTERNAL(BOOL,IN1)
  __DECLARE_EXTERNAL(BOOL,IN2)
  __DECLARE_EXTERNAL(BOOL,IN3)
  __DECLARE_EXTERNAL(BOOL,IN4)
  __DECLARE_EXTERNAL(BOOL,IN5)
  __DECLARE_EXTERNAL(BOOL,IN6)
  __DECLARE_EXTERNAL(BOOL,IN7)
  __DECLARE_EXTERNAL(BOOL,IN8)
  __DECLARE_EXTERNAL(BOOL,IN9)
  __DECLARE_EXTERNAL(BOOL,IN10)
  __DECLARE_EXTERNAL(BOOL,IN11)
  __DECLARE_EXTERNAL(BOOL,IN12)
  __DECLARE_EXTERNAL(BOOL,IN13)
  __DECLARE_EXTERNAL(BOOL,IN14)
  __DECLARE_EXTERNAL(BOOL,IN15)
  __DECLARE_EXTERNAL(BOOL,OUT0)
  __DECLARE_EXTERNAL(BOOL,OUT1)
  __DECLARE_EXTERNAL(BOOL,OUT2)
  __DECLARE_EXTERNAL(BOOL,OUT3)
  __DECLARE_EXTERNAL(BOOL,OUT4)
  __DECLARE_EXTERNAL(BOOL,OUT5)
  __DECLARE_EXTERNAL(BOOL,OUT6)
  __DECLARE_EXTERNAL(BOOL,OUT7)
  __DECLARE_EXTERNAL(BOOL,OUT8)
  __DECLARE_EXTERNAL(BOOL,OUT9)
  __DECLARE_EXTERNAL(BOOL,OUT10)
  __DECLARE_EXTERNAL(BOOL,OUT11)
  __DECLARE_EXTERNAL(BOOL,OUT12)
  __DECLARE_EXTERNAL(BOOL,OUT13)
  __DECLARE_EXTERNAL(BOOL,OUT14)
  __DECLARE_VAR(BOOL,TEMPRY)

} INOUTCHK;

void INOUTCHK_init__(INOUTCHK *data__, BOOL retain);
// Code part
void INOUTCHK_body__(INOUTCHK *data__);
// PROGRAM INBITINTERFACE
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,IN_0)
  __DECLARE_VAR(BOOL,IN_1)
  __DECLARE_VAR(BOOL,IN_2)
  __DECLARE_VAR(BOOL,IN_3)
  __DECLARE_VAR(BOOL,IN_4)
  __DECLARE_VAR(BOOL,IN_5)
  __DECLARE_VAR(BOOL,IN_6)
  __DECLARE_VAR(BOOL,IN_7)
  __DECLARE_VAR(BOOL,IN_8)
  __DECLARE_VAR(BOOL,IN_9)
  __DECLARE_VAR(BOOL,IN_10)
  __DECLARE_VAR(BOOL,IN_11)
  __DECLARE_VAR(BOOL,IN_12)
  __DECLARE_VAR(BOOL,IN_13)
  __DECLARE_VAR(BOOL,IN_14)
  __DECLARE_VAR(BOOL,IN_15)
  __DECLARE_VAR(BOOL,IN16)
  __DECLARE_EXTERNAL(BOOL,IN0)
  __DECLARE_EXTERNAL(BOOL,IN1)
  __DECLARE_EXTERNAL(BOOL,IN2)
  __DECLARE_EXTERNAL(BOOL,IN3)
  __DECLARE_EXTERNAL(BOOL,IN4)
  __DECLARE_EXTERNAL(BOOL,IN5)
  __DECLARE_EXTERNAL(BOOL,IN6)
  __DECLARE_EXTERNAL(BOOL,IN7)
  __DECLARE_EXTERNAL(BOOL,IN8)
  __DECLARE_EXTERNAL(BOOL,IN9)
  __DECLARE_EXTERNAL(BOOL,IN10)
  __DECLARE_EXTERNAL(BOOL,IN11)
  __DECLARE_EXTERNAL(BOOL,IN12)
  __DECLARE_EXTERNAL(BOOL,IN13)
  __DECLARE_EXTERNAL(BOOL,IN14)
  __DECLARE_EXTERNAL(BOOL,IN15)

} INBITINTERFACE;

void INBITINTERFACE_init__(INBITINTERFACE *data__, BOOL retain);
// Code part
void INBITINTERFACE_body__(INBITINTERFACE *data__);
#endif //__POUS_H
