TYPE
  LOGLEVEL : (CRITICAL, WARNING, INFO, DEBUG) := INFO;
END_TYPE

FUNCTION_BLOCK LOGGER
  VAR_INPUT
    TRIG : BOOL;
    MSG : STRING;
    LEVEL : LOGLEVEL := INFO;
  END_VAR
  VAR
    TRIG0 : BOOL;
  END_VAR

  IF TRIG AND NOT TRIG0 THEN
  {{
   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  }}
  END_IF;
  TRIG0:=TRIG;
END_FUNCTION_BLOCK



FUNCTION_BLOCK python_eval
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_poll
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_gear
  VAR_INPUT
    N : UINT;
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    py_eval : python_eval;
    COUNTER : UINT;
    _TMP_ADD10_OUT : UINT;
    _TMP_EQ13_OUT : BOOL;
    _TMP_SEL15_OUT : UINT;
    _TMP_AND7_OUT : BOOL;
  END_VAR

  _TMP_ADD10_OUT := ADD(COUNTER, 1);
  _TMP_EQ13_OUT := EQ(N, _TMP_ADD10_OUT);
  _TMP_SEL15_OUT := SEL(_TMP_EQ13_OUT, _TMP_ADD10_OUT, 0);
  COUNTER := _TMP_SEL15_OUT;
  _TMP_AND7_OUT := AND(_TMP_EQ13_OUT, TRIG);
  py_eval(TRIG := _TMP_AND7_OUT, CODE := CODE);
  ACK := py_eval.ACK;
  RESULT := py_eval.RESULT;
END_FUNCTION_BLOCK


PROGRAM InOutChk
  VAR_EXTERNAL
    IN0 : BOOL;
    IN1 : BOOL;
    IN2 : BOOL;
    IN3 : BOOL;
    IN4 : BOOL;
    IN5 : BOOL;
    IN6 : BOOL;
    IN7 : BOOL;
    IN8 : BOOL;
    IN9 : BOOL;
    IN10 : BOOL;
    IN11 : BOOL;
    IN12 : BOOL;
    IN13 : BOOL;
    IN14 : BOOL;
    IN15 : BOOL;
    OUT0 : BOOL;
    OUT1 : BOOL;
    OUT2 : BOOL;
    OUT3 : BOOL;
    OUT4 : BOOL;
    OUT5 : BOOL;
    OUT6 : BOOL;
    OUT7 : BOOL;
    OUT8 : BOOL;
    OUT9 : BOOL;
    OUT10 : BOOL;
    OUT11 : BOOL;
    OUT12 : BOOL;
    OUT13 : BOOL;
    OUT14 : BOOL;
  END_VAR
  VAR
    TempRY : BOOL;
  END_VAR

  OUT0 := IN0;
  OUT1 := IN1;
  OUT2 := IN2;
  OUT3 := IN3;
  OUT4 := IN4;
  OUT5 := IN5;
  OUT6 := IN6;
  OUT7 := IN7;
  OUT8 := IN8;
  OUT9 := IN9;
  OUT10 := IN10;
  OUT11 := IN11;
  OUT12 := IN12;
  OUT13 := IN13;
  TempRY := IN14 OR IN15;
  OUT14 := TempRY;
END_PROGRAM

PROGRAM InBitInterface
  VAR
    in_0 : BOOL;
    in_1 : BOOL;
    in_2 : BOOL;
    in_3 : BOOL;
    in_4 : BOOL;
    in_5 : BOOL;
    in_6 : BOOL;
    in_7 : BOOL;
    in_8 : BOOL;
    in_9 : BOOL;
    in_10 : BOOL;
    in_11 : BOOL;
    in_12 : BOOL;
    in_13 : BOOL;
    in_14 : BOOL;
    in_15 : BOOL;
    in16 : BOOL;
  END_VAR
  VAR_EXTERNAL
    IN0 : BOOL;
    IN1 : BOOL;
    IN2 : BOOL;
    IN3 : BOOL;
    IN4 : BOOL;
    IN5 : BOOL;
    IN6 : BOOL;
    IN7 : BOOL;
    IN8 : BOOL;
    IN9 : BOOL;
    IN10 : BOOL;
    IN11 : BOOL;
    IN12 : BOOL;
    IN13 : BOOL;
    IN14 : BOOL;
    IN15 : BOOL;
  END_VAR

  IN0 := NOT(in_0);
  IN1 := NOT(in_1);
  IN2 := in_2;
  IN3 := in_3;
  IN4 := in_4;
  IN5 := in_5;
  IN6 := in_6;
  IN7 := in_7;
  IN8 := in_8;
  IN9 := in_9;
  IN10 := in_10;
  IN11 := in_11;
  IN12 := in_12;
  IN13 := in_13;
  IN14 := in_14;
  IN15 := in_15;
END_PROGRAM


CONFIGURATION Config0
  VAR_GLOBAL
    IN0 : BOOL;
    IN1 : BOOL;
    IN2 : BOOL;
    IN3 : BOOL;
    IN4 : BOOL;
    IN5 : BOOL;
    IN6 : BOOL;
    IN7 : BOOL;
    IN8 : BOOL;
    IN9 : BOOL;
    IN10 : BOOL;
    IN11 : BOOL;
    IN12 : BOOL;
    IN13 : BOOL;
    IN14 : BOOL;
    IN15 : BOOL;
    OUT0 : BOOL;
    OUT1 : BOOL;
    OUT2 : BOOL;
    OUT3 : BOOL;
    OUT4 : BOOL;
    OUT5 : BOOL;
    OUT6 : BOOL;
    OUT7 : BOOL;
    OUT8 : BOOL;
    OUT9 : BOOL;
    OUT10 : BOOL;
    OUT11 : BOOL;
    OUT12 : BOOL;
    OUT13 : BOOL;
    OUT14 : BOOL;
  END_VAR

  RESOURCE Res0 ON PLC
    TASK task0(INTERVAL := T#20ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : InBitInterface;
    PROGRAM instance1 WITH task0 : InOutChk;
  END_RESOURCE
END_CONFIGURATION
